Foreman - Bug #6006

OS facts should not overwrite the OS selected to provision with
06/02/2014 07:38 AM - Dominic Cleal

Status: Closed
Priority: Normal
Assignee: Trey Dockendorf
Category: Importers
Target version: 1.15.0
Difficulty: Fixed in Releases:
Triaged: Found in Releases:
Bugzilla link: 1261667 Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p
ull/4077
Description

Migrated from https:/github.com/theforeman/foreman/issues/1489

We setup a specific Operatingsystem, 'Ubuntu 12.04 + 3.2.0-59 kernel', and selected this OS in the hostgroup for machines that
need this specific kernel.

We then built the hosts successfully.

Post-build, the Operatingsystem was set to 'Ubuntu 12.04.4 LTS'. This then caused a re-build of the system to fail, as the wrong
kernel was installed.

| suspect the error is around line 47 in app/services/facts_parser.rb, as for our host, the os.description field is blank, because it is
filled from the hostgroup. | am unclear on what a good fix for this is, but | will try and dig into more and produce a pull request, unless
someone has an easy idea on it.

Another thought of mine is that facts collection should not overwrite fields that are critical to the provisioning process.

Related issues:

Related to Foreman - Bug #11937: Yum updating a managed host can invalidate i... New 09/23/2015
Related to Foreman - Bug #12076: Unable to create Mulitple OS with same name,... Rejected 10/06/2015
Related to Foreman - Feature #15078: Disable updates to operating system from... Duplicate 05/18/2016
Has duplicate Foreman - Feature #12235: OS minor versions should all use the ... Duplicate 10/21/2015

Associated revisions

Revision ef9f2f9d - 12/09/2016 03:51 AM - Trey Dockendorf
Fixes #6006 - Add options to disable updates from facts

Add option ignore_facts_for_operatingsystem:
do not update system's operating system based on facts

Add option ignore_facts_for_domain:
do not update system's domain based on facts

History

#1 - 06/02/2014 07:39 AM - Dominic Cleal

I think it's likely creating a new OS if the exact major/minor numbers aren't found on the existing OS, this might contain the ".4" too.
#2 - 08/07/2014 05:02 PM - Aaron Stone

There are at least three problems here, all of which are caused by Foreman reassigning the Operating System out from under us.
Problem 1: | assigned the host an OS, but Foreman invented a new OS entry instead of leaving it alone.

Problem 2: | assigned the host an OS, but Foreman reassigned the host to a different OS with the same name and version, because two entries with
matching name and version numbers could be returning in different order from the database at different queries. Instead of leaving it alone.

Problem 3: | assigned the host an OS, and months later did a package upgrade which changed the OS micro version, causing Foreman to reassign
the OS instead of leaving it alone.

We have operating System entries like "Ubuntu 12.04 + 3.2.0 kernel" and "Ubuntu 12.04 + 3.13.0 kernel". Based on which OS | assigned to a
machine, | have different netboot, templates, and parameters. These are set up as:

Name: Ubuntu
Major: 12
Minor: 04
Description: + 3.2.0 kernel
/ Description: + 3.13.0 kernel
/ Description: with alternate netboot, etc.

Can we disable Foreman from reassigning the OS based on the received facts?
Should we be using some other mechanism to control the host OS installation parameters!?

#3 - 10/07/2015 03:12 AM - Dominic Cleal

https://groups.google.com/forum/#!topic/foreman-dev/d20WhUG3J_A has some discussion.

#4 - 10/20/2015 06:30 AM - Dominic Cleal

- Related to Bug #11937: Yum updating a managed host can invalidate its data in Foreman. added

#5 - 10/21/2015 08:30 AM - Dominic Cleal

- Has duplicate Feature #12235: OS minor versions should all use the same templates, installation media, and partition tables added

#6 - 10/21/2015 08:30 AM - Dominic Cleal

- Related to Bug #12076: Unable to create Mulitple OS with same name, major, minor added

#7 - 05/18/2016 08:47 AM - Trey Dockendorf
- Related to Feature #15078: Disable updates to operating system from Puppet facts added

#8 - 12/02/2016 11:50 AM - The Foreman Bot
- Status changed from New to Ready For Testing
- Pull request https://github.com/theforeman/foreman/pull/4077 added

#9 - 12/06/2016 08:09 AM - Tomer Brisker
- Bugzilla link set to 1261667

#10 - 12/09/2016 04:01 AM - Anonymous
- Status changed from Ready For Testing to Closed
- % Done changed from 0 to 100

Applied in changeset ef9f2f9d14ac0a501c76e23b3d2acal39b267943a.

#11 - 12/12/2016 06:01 AM - Dominic Cleal
- Assignee set to Trey Dockendorf

- translation missing: en.field_release set to 209
